Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_precip.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_precip.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_precip.f90	(revision 5609)
@@ -18,9 +18,9 @@
 SUBROUTINE histprecip_precld( &
            klon, dtime, iftop, paprsdn, paprsup, pplay, zt, ztupnew, zq, &
-           zmqc, zneb, znebprecip, znebprecipclr, &
+           zmqc, zneb, znebprecip, znebprecipclr, icesed_flux, &
            zrfl, zrflclr, zrflcld, zifl, ziflclr, ziflcld, dqreva, dqssub &
            )
 
-USE lmdz_lscp_ini, ONLY : iflag_evap_prec
+USE lmdz_lscp_ini, ONLY : iflag_evap_prec, ok_ice_sedim
 USE lmdz_lscp_ini, ONLY : coef_eva, coef_sub, ztfondue
 USE lmdz_lscp_ini, ONLY : RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RG
@@ -44,4 +44,5 @@
 REAL,    INTENT(INOUT), DIMENSION(klon) :: zq             !--current water vapor specific humidity (includes evaporated qi and ql) [kg/kg]
 REAL,    INTENT(INOUT), DIMENSION(klon) :: zmqc           !--specific humidity in the precipitation falling from the upper layer [kg/kg]
+REAL,    INTENT(IN),    DIMENSION(klon) :: icesed_flux    !--sedimentated ice flux [kg/s/m2]
 
 REAL,    INTENT(IN),    DIMENSION(klon) :: zneb           !--cloud fraction IN THE LAYER ABOVE [-]
@@ -74,4 +75,5 @@
 
 REAL :: zmelt
+REAL :: qice_sedim
 INTEGER :: i
 
@@ -118,4 +120,24 @@
   ENDDO
 
+ENDIF
+
+!--------------------
+!-- ICE SEDIMENTATION
+!--------------------
+IF ( ok_ice_sedim ) THEN
+  DO i =1, klon
+    !--If the sedimentation of ice crystals is activated, the falling ice is sublimated and
+    !--added to the total water content of the gridbox
+    IF ( icesed_flux(i) .GT. 0. ) THEN
+      qice_sedim = icesed_flux(i) / ( paprsdn(i) - paprsup(i) ) * RG * dtime
+      !--Vapor is updated after evaporation/sublimation (it is increased)
+      zq(i) = zq(i) + qice_sedim
+      !--Air and precip temperature (i.e., gridbox temperature)
+      !--is updated due to latent heat cooling
+      zt(i) = zt(i) &
+              - qice_sedim * RLSTT / RCPD &
+              / ( 1. + RVTMP2 * ( zq(i) + zmqc(i) ) )
+    ENDIF ! ok_ice_sedim
+  ENDDO
 ENDIF
 
@@ -307,9 +329,9 @@
 
 SUBROUTINE histprecip_postcld( &
-        klon, dtime, iftop, paprsdn, paprsup, pplay, ctot_vol, ptconv, zdqsdT_raw, &
-        zt, zq, zoliq, zoliql, zoliqi, zcond, zfice, zmqc, &
+        klon, dtime, iftop, paprsdn, paprsup, pplay, ctot_vol, ptconv, pt_pron_clds, &
+        zdqsdT_raw, zt, zq, zoliq, zoliql, zoliqi, zcond, zfice, zmqc, icesed_flux, &
         rneb, znebprecipclr, znebprecipcld, zneb, tot_zneb, zrho_up, zvelo_up, &
         zrfl, zrflclr, zrflcld, zifl, ziflclr, ziflcld, &
-        zradocond, zradoice, dqrauto, dqsauto &
+        zradocond, zradoice, dqrauto, dqsauto, dqised &
         )
 
@@ -321,4 +343,5 @@
                           iflag_autoconversion, ok_radocond_snow, ok_bug_phase_lscp, &
                           niter_lscp
+USE lmdz_lscp_ini, ONLY : ok_ice_sedim, fallice_sedim, eps
 USE lmdz_lscp_tools, ONLY : fallice_velocity
 
@@ -335,4 +358,5 @@
 REAL,    INTENT(IN),    DIMENSION(klon) :: ctot_vol       !--volumic cloud fraction [-]
 LOGICAL, INTENT(IN),    DIMENSION(klon) :: ptconv         !--true if we are in a convective point
+LOGICAL, INTENT(IN),    DIMENSION(klon) :: pt_pron_clds   !--true if we are in a prognostic clouds point
 REAL,    INTENT(IN),    DIMENSION(klon) :: zdqsdT_raw     !--derivative of qsat w.r.t. temperature times L/Cp [SI]
 
@@ -360,4 +384,5 @@
 REAL,    INTENT(INOUT), DIMENSION(klon) :: ziflclr        !--flux of snow gridbox-mean in clear sky [kg/s/m2]
 REAL,    INTENT(INOUT), DIMENSION(klon) :: ziflcld        !--flux of snow gridbox-mean in cloudy air [kg/s/m2]
+REAL,    INTENT(OUT),   DIMENSION(klon) :: icesed_flux    !--flux of sedimentated ice [kg/s/m2]
 
 REAL,    INTENT(OUT),   DIMENSION(klon) :: zradocond      !--condensed water used in the radiation scheme [kg/kg]
@@ -365,4 +390,5 @@
 REAL,    INTENT(OUT),   DIMENSION(klon) :: dqrauto        !--rain tendency due to autoconversion of cloud liquid [kg/kg/s]
 REAL,    INTENT(OUT),   DIMENSION(klon) :: dqsauto        !--snow tendency due to autoconversion of cloud ice [kg/kg/s]
+REAL,    INTENT(INOUT), DIMENSION(klon) :: dqised         !--ice water content tendency due to sedimentation of ice crystals [kg/kg/s]
 
 
@@ -390,4 +416,8 @@
 REAL, DIMENSION(klon) :: ziflprev
 
+! Local variable for sedimentation
+REAL :: iwcg, tempc, icevelo
+REAL :: qice_sedim
+
 ! Misc
 INTEGER :: i, n
@@ -398,4 +428,6 @@
 zqpreci(:) = 0.
 ziflprev(:) = 0.
+
+icesed_flux(:) = 0.
 
 
@@ -474,5 +506,5 @@
   ENDDO
 
-  CALL fallice_velocity(klon, iwc, zt, zrho, pplay, ptconv, zvelo)
+  CALL fallice_velocity(klon, iwc, zt, zrho, pplay, ptconv, pt_pron_clds, zvelo)
 
   DO i = 1, klon
@@ -656,4 +688,39 @@
 ENDDO
 
+!---------------------------------------------------------
+!--                  ICE SEDIMENTATION
+!---------------------------------------------------------
+IF ( ok_ice_sedim ) THEN
+
+  DO i = 1, klon
+    IF ( ( zoliqi(i) .GT. 0. ) .AND. ( rneb(i) .GT. eps ) .AND. pt_pron_clds(i) ) THEN
+
+      iwcg = MAX( zrho(i) * zoliqi(i) / zneb(i) * 1000., eps ) ! iwc in g/m3
+      tempc = zt(i) - RTT ! celcius temp
+      ! so-called 'empirical parameterization' in Stubenrauch et al. 2019
+      IF ( tempc .GE. -60. ) THEN
+        icevelo = EXP( 1.9714 + 0.00216078 * tempc &
+                - ( 0.0000414122 * tempc**2 + 0.00538922 * tempc + 0.0516344 ) * LOG(iwcg) )
+      ELSE
+        icevelo = 65. * iwcg**0.2 * ( 15000. / pplay(i) )**0.15
+      ENDIF
+      icevelo = fallice_sedim * icevelo / 100.0 ! from cm/s to m/s
+
+      qice_sedim = zoliqi(i) * MIN(1., icevelo * dtime / zdz(i))
+      !--We remove the ice that was sedimentated in the gridbox (it cannot sedimentate two
+      !--times in the same timestep)
+      !qice_sedim = MAX(0., qice_sedim - dqised(i) * dtime)
+      !--Add tendencies
+      zoliqi(i) = zoliqi(i) - qice_sedim
+      zoliq(i)  = zoliq(i)  - qice_sedim
+      !--Convert to flux
+      icesed_flux(i) = qice_sedim * ( paprsdn(i) - paprsup(i) ) / RG / dtime
+
+      !--Diagnostic tendencies
+      dqised(i) = dqised(i) - qice_sedim / dtime
+    ENDIF
+  ENDDO
+ENDIF
+
 ! LTP: limit of surface cloud fraction covered by precipitation when the local intensity of the flux is below rain_int_min
 ! if iflag_evap_prec>=4
@@ -713,9 +780,8 @@
 SUBROUTINE poprecip_precld( &
            klon, dtime, iftop, paprsdn, paprsup, pplay, temp, tempupnew, qvap, &
-           qprecip, precipfracclr, precipfraccld, qvapclrup, qtotupnew, qice_sedim, &
+           qprecip, precipfracclr, precipfraccld, qvapclrup, qtotupnew, icesed_flux, &
            cldfra, qvc, qliq, qice, &
            rain, rainclr, raincld, snow, snowclr, snowcld, &
-           dqreva, dqssub, dcfsed, dqvcsed &
-           )
+           dqreva, dqssub)
 
 USE lmdz_lscp_ini, ONLY : coef_eva, coef_sub, expo_eva, expo_sub, thresh_precip_frac
@@ -749,5 +815,5 @@
 REAL,    INTENT(IN),    DIMENSION(klon) :: qvapclrup      !--clear-sky specific humidity IN THE LAYER ABOVE [kg/kg]
 REAL,    INTENT(IN),    DIMENSION(klon) :: qtotupnew      !--total specific humidity IN THE LAYER ABOVE [kg/kg]
-REAL,    INTENT(IN),    DIMENSION(klon) :: qice_sedim     !--ice water content that sedimentated from the layer above [kg/kg]
+REAL,    INTENT(IN),    DIMENSION(klon) :: icesed_flux    !--sedimentated ice water flux [kg/s/m2]
 
 REAL,    INTENT(INOUT), DIMENSION(klon) :: cldfra         !--cloud fraction at the beginning of lscp - used only if the cloud properties are advected [-]
@@ -766,6 +832,4 @@
 REAL,    INTENT(OUT),   DIMENSION(klon) :: dqreva         !--rain tendency due to evaporation [kg/kg/s]
 REAL,    INTENT(OUT),   DIMENSION(klon) :: dqssub         !--snow tendency due to sublimation [kg/kg/s]
-REAL,    INTENT(OUT),   DIMENSION(klon) :: dcfsed         !--cloud fraction tendency due to sedimentation of ice crystals [s-1]
-REAL,    INTENT(OUT),   DIMENSION(klon) :: dqvcsed        !--cloud water vapor tendency due to sedimentation of ice crystals [kg/kg/s]
 
 
@@ -791,4 +855,6 @@
 !--Specific heat constant
 REAL :: cpair, cpw
+!--Specific ice water content sedimentated
+REAL :: qice_sedim
 
 !--Initialisation
@@ -796,8 +862,4 @@
 dqreva(:) = 0.
 dqssub(:) = 0.
-IF ( ok_ice_sedim .AND. ok_ice_supersat ) THEN
-  dcfsed(:) = 0.
-  dqvcsed(:) = 0.
-ENDIF
 
 !-- dhum_to_dflux = rho * dz/dt = 1 / g * dP/dt
@@ -943,34 +1005,13 @@
     !--If the sedimentation of ice crystals is activated, the falling ice is sublimated and
     !--added to the total water content of the gridbox
-    IF ( ok_ice_sedim .AND. ( qice_sedim(i) .GT. 0. ) ) THEN
+    IF ( icesed_flux(i) .GT. 0. ) THEN
+      qice_sedim = icesed_flux(i) / dhum_to_dflux(i)
       !--Vapor is updated after evaporation/sublimation (it is increased)
-      qvap(i) = qvap(i) + qice_sedim(i)
+      qvap(i) = qvap(i) + qice_sedim
       !--Air and precip temperature (i.e., gridbox temperature)
       !--is updated due to latent heat cooling
       temp(i) = temp(i) &
-              - qice_sedim(i) * RLSTT / RCPD &
+              - qice_sedim * RLSTT / RCPD &
               / ( 1. + RVTMP2 * ( qvap(i) + qprecip(i) ) )
-    
-      IF ( ok_ice_supersat ) THEN
-        !--If ice supersaturation is activated, the cloud properties are prognostic.
-        !--The falling ice is then considered a new cloud in the gridbox.
-        !--BEWARE with this parameterisation, we can create a new cloud with a much
-        !--different ice water content and water vapor content than the existing cloud
-        !--(if it exists). This implies than unphysical fluxes of ice and vapor
-        !--occur between the existing cloud and the newly formed cloud (from sedimentation).
-        !--Note also that currently, the precipitation scheme assume a maximum
-        !--random overlap, meaning that the new formed clouds will not be affected
-        !--by vertical wind shear.
-        ! Maybe we should reduce dcfsed?
-        dcfsed(i) = precipfracclr_tmp(i)
-        dqvcsed(i) = qvapclr * dcfsed(i)
-        !--Add tendencies
-        cldfra(i) = cldfra(i) + dcfsed(i)
-        qvc(i) = qvc(i) + dqvcsed(i)
-        qice(i) = qice(i) + qice_sedim(i)
-        !--Normalisation
-        dcfsed(i) = dcfsed(i) / dtime
-        dqvcsed(i) = dqvcsed(i) / dtime
-      ENDIF
     ENDIF ! ok_ice_sedim
 
@@ -1326,5 +1367,5 @@
 SUBROUTINE poprecip_postcld( &
            klon, dtime, paprsdn, paprsup, pplay, ctot_vol, ptconv, &
-           temp, qvap, qliq, qice, icefrac, cldfra, qice_sedim, &
+           temp, qvap, qliq, qice, icefrac, cldfra, icesed_flux, &
            precipfracclr, precipfraccld, &
            rain, rainclr, raincld, snow, snowclr, snowcld, &
@@ -1347,5 +1388,5 @@
                           rain_fallspeed_clr, rain_fallspeed_cld,              &
                           snow_fallspeed_clr, snow_fallspeed_cld,              &
-                          ok_ice_sedim, ice_fallspeed_sedim
+                          ok_ice_sedim, fallice_sedim
 
 
@@ -1368,5 +1409,4 @@
 REAL,    INTENT(IN),    DIMENSION(klon) :: icefrac        !--ice fraction [-]
 REAL,    INTENT(IN),    DIMENSION(klon) :: cldfra         !--cloud fraction [-]
-REAL,    INTENT(INOUT), DIMENSION(klon) :: qice_sedim     !--quantity of sedimentated ice [kg/kg]
 
 REAL,    INTENT(INOUT), DIMENSION(klon) :: precipfracclr  !--fraction of precipitation in the clear sky IN THE LAYER ABOVE [-]
@@ -1382,4 +1422,5 @@
 REAL,    INTENT(INOUT), DIMENSION(klon) :: snowcld        !--flux of snow gridbox-mean in cloudy air coming from the layer above [kg/s/m2]
 
+REAL,    INTENT(OUT),   DIMENSION(klon) :: icesed_flux    !--flux of sedimentated ice [kg/s/m2]
 REAL,    INTENT(OUT),   DIMENSION(klon) :: qraindiag      !--DIAGNOSTIC specific rain content [kg/kg]
 REAL,    INTENT(OUT),   DIMENSION(klon) :: qsnowdiag      !--DIAGNOSTIC specific snow content [kg/kg]
@@ -1393,5 +1434,5 @@
 REAL,    INTENT(OUT),   DIMENSION(klon) :: dqsfreez       !--snow tendency due to freezing [kg/kg/s]
 REAL,    INTENT(OUT),   DIMENSION(klon) :: dqrfreez       !--rain tendency due to freezing [kg/kg/s]
-REAL,    INTENT(OUT),   DIMENSION(klon) :: dqised         !--ice water content tendency due to sedimentation of ice crystals [kg/kg/s]
+REAL,    INTENT(INOUT), DIMENSION(klon) :: dqised         !--ice water content tendency due to sedimentation of ice crystals [kg/kg/s]
 
 
@@ -1436,5 +1477,6 @@
 
 !--Ice sedimentation
-REAL :: dz, qice_sedim_tmp
+REAL :: iwcg, tempc, icevelo
+REAL :: dz, qice_sedim
 
 
@@ -1443,4 +1485,5 @@
 
 qzero(:)    = 0.
+icesed_flux(:) = 0.
 
 dqrcol(:)   = 0.
@@ -1453,5 +1496,4 @@
 dqrfreez(:) = 0.
 dqsfreez(:) = 0.
-IF ( ok_ice_sedim ) dqised(:) = 0.
 
 
@@ -1917,18 +1959,29 @@
   !---------------------------------------------------------
   IF ( ok_ice_sedim ) THEN
-    qice_sedim_tmp = 0.
-
-    IF ( temp(i) .LE. temp_nowater ) THEN
+
+    IF ( ( qice(i) .GT. 0. ) .AND. ( cldfra(i) .GT. eps ) ) THEN
+
       rho = pplay(i) / temp(i) / RD
+      iwcg = MAX( rho * qice(i) / cldfra(i) * 1000., eps ) ! iwc in g/m3
+      tempc = temp(i) - RTT ! celcius temp
+      ! so-called 'empirical parameterization' in Stubenrauch et al. 2019
+      IF ( tempc .GE. -60. ) THEN
+        icevelo = EXP( 1.9714 + 0.00216078 * tempc &
+                - ( 0.0000414122 * tempc**2 + 0.00538922 * tempc + 0.0516344 ) * LOG(iwcg) )
+      ELSE
+        icevelo = 65. * iwcg**0.2 * ( 15000. / pplay(i) )**0.15
+      ENDIF
+      icevelo = fallice_sedim * icevelo / 100.0 ! from cm/s to m/s
+
       dz = ( paprsdn(i) - paprsup(i) ) / RG / rho
-      qice_sedim_tmp = qice(i) * MIN(1., ice_fallspeed_sedim * dtime / dz)
+      qice_sedim = qice(i) * MIN(1., icevelo * dtime / dz)
       !--Add tendencies
-      qice(i) = qice(i) - qice_sedim_tmp
-    ENDIF
-
-    !--Diagnostic tendencies
-    dqised(i) = ( qice_sedim(i) - qice_sedim_tmp ) / dtime
-    !--Save quantity that will be sedimentated in the layer below
-    qice_sedim(i) = qice_sedim_tmp
+      qice(i) = qice(i) - qice_sedim
+      !--Convert to flux
+      icesed_flux(i) = qice_sedim * dhum_to_dflux(i)
+
+      !--Diagnostic tendencies
+      dqised(i) = dqised(i) - qice_sedim / dtime
+    ENDIF
   ENDIF
 
Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_tools.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_tools.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_tools.f90	(revision 5609)
@@ -6,5 +6,5 @@
 
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-SUBROUTINE FALLICE_VELOCITY(klon,iwc,temp,rho,pres,ptconv,velo)
+SUBROUTINE FALLICE_VELOCITY(klon,iwc,temp,rho,pres,ptconv,ptpronclds,velo)
 
     ! Ref:
@@ -16,7 +16,7 @@
     ! 3212–3234. https://doi.org/10.1029/2019MS001642
     
-    use lmdz_lscp_ini, only: iflag_vice, ffallv_con, ffallv_lsc
+    use lmdz_lscp_ini, only: iflag_vice, ffallv_con, ffallv_lsc, ffallv_issr
     use lmdz_lscp_ini, only: cice_velo, dice_velo
-    use lmdz_lscp_ini, only: ok_bug_ice_fallspeed
+    use lmdz_lscp_ini, only: ok_bug_ice_fallspeed, eps
 
     IMPLICIT NONE
@@ -28,4 +28,5 @@
     REAL, INTENT(IN), DIMENSION(klon) :: pres      ! air pressure [Pa]
     LOGICAL, INTENT(IN), DIMENSION(klon) :: ptconv    ! convective point  [-]
+    LOGICAL, INTENT(IN), DIMENSION(klon) :: ptpronclds! prognostic clouds point  [-]
 
     REAL, INTENT(OUT), DIMENSION(klon) :: velo    ! fallspeed velocity of crystals [m/s]
@@ -42,4 +43,6 @@
         IF (ptconv(i)) THEN
             fallv_tun=ffallv_con
+        ELSEIF (ptpronclds(i)) THEN
+            fallv_tun=ffallv_issr
         ELSE
             fallv_tun=ffallv_lsc
@@ -51,5 +54,5 @@
         ELSE
             ! AB the threshold is way too high, we reduce it
-            iwcg=MAX(iwc(i)*1000.,1E-10) ! iwc in g/m3. We set a minimum value to prevent from division by 0
+            iwcg=MAX(iwc(i)*1000.,eps) ! iwc in g/m3. We set a minimum value to prevent from division by 0
         ENDIF
         phpa=pres(i)/100.    ! pressure in hPa
Index: LMDZ6/branches/contrails/libf/phylmd/phyetat0_mod.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/phyetat0_mod.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/phyetat0_mod.f90	(revision 5609)
@@ -18,11 +18,12 @@
   USE surface_data,     ONLY : type_ocean, version_ocean
   USE phyetat0_get_mod, ONLY : phyetat0_get, phyetat0_srf
-  USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, phys_tstep, &
+  USE phys_state_var_mod, ONLY : ancien_ok, cwcon, clwcon, detr_therm, phys_tstep, &
        qsol, fevap, z0m, z0h, agesno, &
        du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
        falb_dir, falb_dif, prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien, &
        ftsol, pbl_tke, pctsrf, q_ancien, ql_ancien, qs_ancien, qbs_ancien, &
-       cf_ancien, qvc_ancien, cfa_ancien, qta_ancien, radpas, radsol, rain_fall, ratqs, &
-       rnebcon, rugoro, sig1, snow_fall, bs_fall, solaire_etat0, sollw, sollwdown, &
+       cf_ancien, qvc_ancien, cfa_ancien, pcf_ancien, qva_ancien, qia_ancien, &
+       radpas, radsol, rain_fall, &
+       ratqs, rnebcon, rugoro, sig1, snow_fall, bs_fall, solaire_etat0, sollw, sollwdown, &
        solsw, solswfdiff, t_ancien, u_ancien, v_ancien, w01, wake_cstar, wake_deltaq, &
        wake_deltat, wake_delta_pbl_TKE, delta_tsurf, beta_aridity, wake_fip, wake_pe, &
@@ -415,4 +416,5 @@
     ancien_ok=ancien_ok.AND.phyetat0_get(cf_ancien,"CFANCIEN","CFANCIEN",0.)
     ancien_ok=ancien_ok.AND.phyetat0_get(qvc_ancien,"QVCANCIEN","QVCANCIEN",0.)
+    found=phyetat0_get(cwcon,"CWCON","CWCON",0.)
   ELSE
     cf_ancien(:,:)=0.
@@ -423,8 +425,12 @@
   IF ( ok_plane_contrail ) THEN
     ancien_ok=ancien_ok.AND.phyetat0_get(cfa_ancien,"CFAANCIEN","CFAANCIEN",0.)
-    ancien_ok=ancien_ok.AND.phyetat0_get(cfa_ancien,"QTAANCIEN","QTAANCIEN",0.)
+    ancien_ok=ancien_ok.AND.phyetat0_get(pcf_ancien,"PCFANCIEN","PCFANCIEN",0.)
+    ancien_ok=ancien_ok.AND.phyetat0_get(qva_ancien,"QVAANCIEN","QVAANCIEN",0.)
+    ancien_ok=ancien_ok.AND.phyetat0_get(qia_ancien,"QIAANCIEN","QIAANCIEN",0.)
   ELSE
     cfa_ancien(:,:)=0.
-    qta_ancien(:,:)=0.
+    pcf_ancien(:,:)=0.
+    qva_ancien(:,:)=0.
+    qia_ancien(:,:)=0.
   ENDIF
 
@@ -458,5 +464,7 @@
   IF ( ok_plane_contrail ) THEN
     IF ( ( maxval(cfa_ancien).EQ.minval(cfa_ancien) ) .OR. &
-         ( maxval(qta_ancien).EQ.minval(qta_ancien) ) ) THEN
+         ( maxval(pcf_ancien).EQ.minval(pcf_ancien) ) .OR. &
+         ( maxval(qva_ancien).EQ.minval(qva_ancien) ) .OR. &
+         ( maxval(qia_ancien).EQ.minval(qia_ancien) ) ) THEN
        ancien_ok=.false.
      ENDIF
Index: LMDZ6/branches/contrails/libf/phylmd/phyredem.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/phyredem.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/phyredem.f90	(revision 5609)
@@ -23,7 +23,7 @@
                                 prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien,      &
                                 ql_ancien, qs_ancien, qbs_ancien, cf_ancien, &
-                                qvc_ancien, cfa_ancien, qta_ancien,          &
-                                u_ancien, v_ancien,                          &
-                                clwcon, rnebcon, ratqs, pbl_tke,             &
+                                qvc_ancien, cfa_ancien, pcf_ancien,          &
+                                qva_ancien, qia_ancien, u_ancien, v_ancien,  &
+                                cwcon, clwcon, rnebcon, ratqs, pbl_tke,      &
                                 wake_delta_pbl_tke, zmax0, f0, sig1, w01,    &
                                 wake_deltat, wake_deltaq, wake_s, awake_s,   &
@@ -255,9 +255,12 @@
       CALL put_field(pass,"CFANCIEN", "CFANCIEN", cf_ancien)
       CALL put_field(pass,"QVCANCIEN", "QVCANCIEN", qvc_ancien)
+      CALL put_field(pass,"CWCON", "CWCON", cwcon)
     ENDIF
 
     IF ( ok_plane_contrail ) THEN
       CALL put_field(pass,"CFAANCIEN", "CFAANCIEN", cfa_ancien)
-      CALL put_field(pass,"QTAANCIEN", "QTAANCIEN", qta_ancien)
+      CALL put_field(pass,"PCFANCIEN", "PCFANCIEN", pcf_ancien)
+      CALL put_field(pass,"QVAANCIEN", "QVAANCIEN", qva_ancien)
+      CALL put_field(pass,"QIAANCIEN", "QIAANCIEN", qia_ancien)
     ENDIF
 
Index: LMDZ6/branches/contrails/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/phys_local_var_mod.F90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/phys_local_var_mod.F90	(revision 5609)
@@ -669,6 +669,10 @@
       REAL, SAVE, ALLOCATABLE :: cfa_seri(:,:), d_cfa_dyn(:,:)
       !$OMP THREADPRIVATE(cfa_seri, d_cfa_dyn)
-      REAL, SAVE, ALLOCATABLE :: qta_seri(:,:), d_qta_dyn(:,:)
-      !$OMP THREADPRIVATE(qta_seri, d_qta_dyn)
+      REAL, SAVE, ALLOCATABLE :: pcf_seri(:,:), d_pcf_dyn(:,:)
+      !$OMP THREADPRIVATE(pcf_seri, d_pcf_dyn)
+      REAL, SAVE, ALLOCATABLE :: qva_seri(:,:), d_qva_dyn(:,:)
+      !$OMP THREADPRIVATE(qva_seri, d_qva_dyn)
+      REAL, SAVE, ALLOCATABLE :: qia_seri(:,:), d_qia_dyn(:,:)
+      !$OMP THREADPRIVATE(qia_seri, d_qia_dyn)
       REAL, SAVE, ALLOCATABLE :: flight_dist(:,:), flight_h2o(:,:)
       !$OMP THREADPRIVATE(flight_dist, flight_h2o)
@@ -677,6 +681,8 @@
       REAL, SAVE, ALLOCATABLE :: potcontfraP(:,:), potcontfraNP(:,:)
       !$OMP THREADPRIVATE(potcontfraP, potcontfraNP)
-      REAL, SAVE, ALLOCATABLE :: qice_cont(:,:), dcfa_cir(:,:), dqta_cir(:,:)
-      !$OMP THREADPRIVATE(qice_cont, dcfa_cir, dqta_cir)
+      REAL, SAVE, ALLOCATABLE :: qice_perscont(:,:)
+      !$OMP THREADPRIVATE(qice_perscont)
+      REAL, SAVE, ALLOCATABLE :: dcfa_cir(:,:), dqta_cir(:,:)
+      !$OMP THREADPRIVATE(dcfa_cir, dqta_cir)
       REAL, SAVE, ALLOCATABLE :: dcfa_ini(:,:), dqia_ini(:,:), dqta_ini(:,:)
       !$OMP THREADPRIVATE(dcfa_ini, dqia_ini, dqta_ini)
@@ -1244,9 +1250,12 @@
       ALLOCATE(d_q_avi(klon,klev))
       ALLOCATE(cfa_seri(klon,klev), d_cfa_dyn(klon,klev))
-      ALLOCATE(qta_seri(klon,klev), d_qta_dyn(klon,klev))
+      ALLOCATE(pcf_seri(klon,klev), d_pcf_dyn(klon,klev))
+      ALLOCATE(qva_seri(klon,klev), d_qva_dyn(klon,klev))
+      ALLOCATE(qia_seri(klon,klev), d_qia_dyn(klon,klev))
       ALLOCATE(flight_dist(klon,klev), flight_h2o(klon,klev))
       ALLOCATE(Tcritcont(klon,klev), qcritcont(klon,klev))
       ALLOCATE(potcontfraP(klon,klev), potcontfraNP(klon,klev))
-      ALLOCATE(qice_cont(klon,klev), dcfa_cir(klon,klev), dqta_cir(klon,klev))
+      ALLOCATE(qice_perscont(klon,klev))
+      ALLOCATE(dcfa_cir(klon,klev), dqta_cir(klon,klev))
       ALLOCATE(dcfa_ini(klon,klev), dqia_ini(klon,klev), dqta_ini(klon,klev))
       ALLOCATE(dcfa_sub(klon,klev), dqia_sub(klon,klev), dqta_sub(klon,klev))
@@ -1661,7 +1670,9 @@
 
 !-- LSCP - aviation and contrails variables
-      DEALLOCATE(d_q_avi, cfa_seri, d_cfa_dyn, qta_seri, d_qta_dyn, flight_dist, flight_h2o)
+      DEALLOCATE(cfa_seri, d_cfa_dyn, pcf_seri, d_pcf_dyn)
+      DEALLOCATE(qva_seri, d_qva_dyn, qia_seri, d_qia_dyn)
+      DEALLOCATE(d_q_avi, flight_dist, flight_h2o)
       DEALLOCATE(Tcritcont, qcritcont, potcontfraP, potcontfraNP)
-      DEALLOCATE(qice_cont, dcfa_cir, dqta_cir, dcfa_ini, dqia_ini, dqta_ini)
+      DEALLOCATE(qice_perscont, dcfa_cir, dqta_cir, dcfa_ini, dqia_ini, dqta_ini)
       DEALLOCATE(dcfa_sub, dqia_sub, dqta_sub, dcfa_mix, dqia_mix, dqta_mix)
       DEALLOCATE(cldfra_nocont, cldtau_nocont, cldemi_nocont, conttau, contemi)
Index: LMDZ6/branches/contrails/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 5609)
@@ -2192,8 +2192,16 @@
   TYPE(ctrl_out), SAVE :: o_dcfadyn = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
     'dcfadyn', 'Dynamics linear contrail fraction tendency', 's-1', (/ ('',i=1,10) /))
-  TYPE(ctrl_out), SAVE :: o_qtaseri = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
-    'qtaseri', 'Linear contrail total specific humidity', 'kg/kg', (/ ('',i=1,10) /))
-  TYPE(ctrl_out), SAVE :: o_dqtadyn = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
-    'dqtadyn', 'Dynamics linear contrail total specific humidity tendency', 'kg/kg/s', (/ ('',i=1,10) /))
+  TYPE(ctrl_out), SAVE :: o_pcfseri = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
+    'pcfseri', 'Contrail induced cirrus fraction', '-', (/ ('',i=1,10) /))
+  TYPE(ctrl_out), SAVE :: o_dpcfdyn = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
+    'dpcfdyn', 'Dynamics contrail induced cirrus fraction tendency', 's-1', (/ ('',i=1,10) /))
+  TYPE(ctrl_out), SAVE :: o_qvaseri = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
+    'qvaseri', 'Linear contrail total specific humidity', 'kg/kg', (/ ('',i=1,10) /))
+  TYPE(ctrl_out), SAVE :: o_dqvadyn = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
+    'dqvadyn', 'Dynamics linear contrail total specific humidity tendency', 'kg/kg/s', (/ ('',i=1,10) /))
+  TYPE(ctrl_out), SAVE :: o_qiaseri = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
+    'qiaseri', 'Linear contrail total specific humidity', 'kg/kg', (/ ('',i=1,10) /))
+  TYPE(ctrl_out), SAVE :: o_dqiadyn = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
+    'dqiadyn', 'Dynamics linear contrail total specific humidity tendency', 'kg/kg/s', (/ ('',i=1,10) /))
   TYPE(ctrl_out), SAVE :: o_Tcritcont = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
     'Tcritcont', 'Temperature threshold for contrail formation', 'K', (/ ('',i=1,10) /))
@@ -2204,6 +2212,6 @@
   TYPE(ctrl_out), SAVE :: o_potcontfraNP = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/),&
     'potcontfraNP', 'Potential non-persistent contrail fraction', '-', (/ ('', i=1,10)/))
-  TYPE(ctrl_out), SAVE :: o_qice_cont = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
-    'qice_cont', 'Linear contrails ice specific humidity', 'kg/kg', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_qice_perscont = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'qice_perscont', 'Contrail induced cirrus ice specific humidity', 'kg/kg', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_dcfaini = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
     'dcfaini', 'Initial formation linear contrail fraction tendency', 's-1', (/ ('', i=1, 10) /))
Index: LMDZ6/branches/contrails/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/phys_output_write_mod.F90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/phys_output_write_mod.F90	(revision 5609)
@@ -229,7 +229,8 @@
          o_issrfra250to300, o_issrfra300to400, o_issrfra400to500, &
 !-- LSCP - aviation variables
-         o_cfaseri, o_dcfadyn, o_qtaseri, o_dqtadyn, o_dqavi, &
+         o_cfaseri, o_dcfadyn, o_pcfseri, o_dpcfdyn, &
+         o_qvaseri, o_dqvadyn, o_qiaseri, o_dqiadyn, o_dqavi, &
          o_Tcritcont, o_qcritcont, o_potcontfraP, o_potcontfraNP, &
-         o_flight_dist, o_flight_h2o, o_qice_cont, o_dcfacir, o_dqtacir, &
+         o_flight_dist, o_flight_h2o, o_qice_perscont, o_dcfacir, o_dqtacir, &
          o_dcfaini, o_dqiaini, o_dqtaini, o_dcfasub, o_dqiasub, o_dqtasub, &
          o_dcfamix, o_dqiamix, o_dqtamix, &
@@ -360,7 +361,8 @@
          issrfra100to150, issrfra150to200, issrfra200to250, &
          issrfra250to300, issrfra300to400, issrfra400to500, &
-         cfa_seri, d_cfa_dyn, qta_seri, d_qta_dyn, d_q_avi, &
+         cfa_seri, d_cfa_dyn, pcf_seri, d_pcf_dyn, &
+         qva_seri, d_qva_dyn, qia_seri, d_qia_dyn, d_q_avi, &
          Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
-         flight_dist, flight_h2o, qice_cont, dcfa_cir, dqta_cir, &
+         flight_dist, flight_h2o, qice_perscont, dcfa_cir, dqta_cir, &
          dcfa_ini, dqia_ini, dqta_ini, dcfa_sub, dqia_sub, dqta_sub, &
          dcfa_mix, dqia_mix, dqta_mix, &
@@ -2105,9 +2107,4 @@
            CALL histwrite_phy(o_dqsfreez, dqsfreez)
            CALL histwrite_phy(o_dqsrim, dqsrim)
-           IF ( ok_ice_sedim ) THEN
-            CALL histwrite_phy(o_dqised, dqised)
-            CALL histwrite_phy(o_dcfsed, dcfsed)
-            CALL histwrite_phy(o_dqvcsed, dqvcsed)
-           ENDIF
            ELSE
             CALL histwrite_phy(o_dqreva, dqreva)
@@ -2116,4 +2113,6 @@
             CALL histwrite_phy(o_dqsauto, dqsauto)
            ENDIF
+           CALL histwrite_phy(o_qsatl, qsatliq)
+           CALL histwrite_phy(o_qsati, qsatice)
        ENDIF
 
@@ -2141,6 +2140,4 @@
          CALL histwrite_phy(o_dqvccon, dqvc_con)
          CALL histwrite_phy(o_dqvcmix, dqvc_mix)
-         CALL histwrite_phy(o_qsatl, qsatliq)
-         CALL histwrite_phy(o_qsati, qsatice)
          CALL histwrite_phy(o_issrfra100to150, issrfra100to150)
          CALL histwrite_phy(o_issrfra150to200, issrfra150to200)
@@ -2149,4 +2146,9 @@
          CALL histwrite_phy(o_issrfra300to400, issrfra300to400)
          CALL histwrite_phy(o_issrfra400to500, issrfra400to500)
+         IF ( ok_ice_sedim ) THEN
+          CALL histwrite_phy(o_dqised, dqised)
+          CALL histwrite_phy(o_dcfsed, dcfsed)
+          CALL histwrite_phy(o_dqvcsed, dqvcsed)
+         ENDIF
        ENDIF
 !-- LSCP - aviation variables
@@ -2154,6 +2156,10 @@
          CALL histwrite_phy(o_cfaseri, cfa_seri)
          CALL histwrite_phy(o_dcfadyn, d_cfa_dyn)
-         CALL histwrite_phy(o_qtaseri, qta_seri)
-         CALL histwrite_phy(o_dqtadyn, d_qta_dyn)
+         CALL histwrite_phy(o_pcfseri, pcf_seri)
+         CALL histwrite_phy(o_dpcfdyn, d_pcf_dyn)
+         CALL histwrite_phy(o_qvaseri, qva_seri)
+         CALL histwrite_phy(o_dqvadyn, d_qva_dyn)
+         CALL histwrite_phy(o_qiaseri, qia_seri)
+         CALL histwrite_phy(o_dqiadyn, d_qia_dyn)
          CALL histwrite_phy(o_flight_dist, flight_dist)
          CALL histwrite_phy(o_Tcritcont, Tcritcont)
@@ -2161,5 +2167,5 @@
          CALL histwrite_phy(o_potcontfraP, potcontfraP)
          CALL histwrite_phy(o_potcontfraNP, potcontfraNP)
-         CALL histwrite_phy(o_qice_cont, qice_cont)
+         CALL histwrite_phy(o_qice_perscont, qice_perscont)
          CALL histwrite_phy(o_dcfacir, dcfa_cir)
          CALL histwrite_phy(o_dqtacir, dqta_cir)
@@ -2219,5 +2225,5 @@
        CALL histwrite_phy(o_dqlphy2d,  zx_tmp_fi2d)
 
-       IF (nqo.EQ.3) THEN
+       IF (nqo .GE. 3) THEN
        CALL histwrite_phy(o_dqsphy,  d_qx(:,:,isol))
        IF (vars_defined) CALL water_int(klon,klev,d_qx(:,:,isol),zmasse,zx_tmp_fi2d)
